// SacomswSS4248.cpp
//

#include "stdafx.h"
#include "stdio.h"
#include "stdlib.h"
#include "SACOMSW_SS4248.h"

#define CURRENT_SPEED       (CBR_9600)
//#define CURRENT_SPEED       (CBR_19200)
#define COM_LINE_INTERVAL   (200)
#define COM_BYTE_INTERVAL   (20)

typedef union
    {
    struct
        {
        unsigned uRelay1: 1;
        unsigned uRelay2: 1;
        unsigned uRelay3: 1;
        unsigned uRelay4: 1;
        unsigned uRelay5: 1;
        unsigned uRelay6: 1;
        unsigned uDataID: 2;
        } BIT;
    unsigned char BYTE;
    } RELAYDATA;


// ***** ÓIϐ **********
// *************************
static HANDLE m_hComm;                  // Access handle of communication port (Win32 API)
static COMMPROP m_aProp;                // Struct of communication port's properties (Win32 API)
static DCB m_aDcb;                      // Struct of communication port's parameters.
static COMMTIMEOUTS m_aCommTimeouts;    // ^CAEgԐݒp\
static BOOL m_bOpen = FALSE;            // I[vĂ邩ǂ
static short m_nCom = -1;               // I[vĂCOM|[gԍ
static short m_nId = -1;                // I[vĂ鑕uIDԍ
static unsigned char ucRelay = 0;       // [
static RELAYDATA stRelay;


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

SACOMSW_SS4248_API BOOL _stdcall SacomswSS4248_Device_Open(short nId, short nCom)
    {
    BOOL bResult;   // TRUE:, FALSE:ُ
    char sCom[32];  // COM1Ȃǂ̒ʐM|[g

    if (nId >= 0 && nId < 64)
        {
        // ʐM|[gI[v
        sprintf(sCom, "\\\\.\\COM%d", nCom);
        m_hComm = CreateFile(sCom, GENERIC_READ | GENERIC_WRITE, 0, NULL, OPEN_EXISTING, NULL, NULL);
        GetCommProperties(m_hComm, (LPCOMMPROP)&m_aProp);

        // ݂̐ݒǂݍ.....
        GetCommState(m_hComm, (LPDCB)&m_aDcb);

        // ݒ肵.....
        m_aDcb.BaudRate = CURRENT_SPEED;
        m_aDcb.ByteSize = 8;
        m_aDcb.fParity  = TRUE;
        m_aDcb.Parity   = ODDPARITY;
        m_aDcb.StopBits = ONESTOPBIT;

        // ߂
        if (SetCommState(m_hComm, (LPDCB)&m_aDcb) != 0)
            {
            // ^CAEg̐ݒ..... ĂȂOSNɒʐMłȂ(ӁXITeraTermPrõ\[XQ)
            memset(&m_aCommTimeouts, 0, sizeof(m_aCommTimeouts));
            m_aCommTimeouts.ReadIntervalTimeout = MAXDWORD;
            m_aCommTimeouts.WriteTotalTimeoutConstant = 100;
            m_aCommTimeouts.ReadTotalTimeoutConstant = 100;
            SetCommTimeouts(m_hComm, (LPCOMMTIMEOUTS)&m_aCommTimeouts);
            m_nId = nId;
            m_nCom = nCom;
            m_bOpen = TRUE;
            bResult = TRUE;     // I
            }
        else
            {
            m_nCom = m_nId = -1;
            m_bOpen = FALSE;
            bResult = FALSE;    // I[vG[
            }
        }
    else
        {
        m_nCom = m_nId = -1;
        m_bOpen = FALSE;
        bResult = FALSE;    // ID͈͊O
        }
    ucRelay = 0;
    stRelay.BYTE = 0;
    return bResult;
    }


SACOMSW_SS4248_API BOOL _stdcall SacomswSS4248_Device_Close(short nId)
    {
    BOOL bResult;   // TRUE:, FALSE:ُ

    if (m_nId == nId && m_bOpen)
        {
        // vȂ̂ŃN[Y
        CloseHandle(m_hComm);
        m_nCom = m_nId = -1;
        m_bOpen = FALSE;
        bResult = TRUE;
        }
    else
        bResult = FALSE;
    return bResult;
    }


SACOMSW_SS4248_API unsigned short _stdcall SacomswSS4248_Out(short nId, char cCh, char cOnOff)
    {
    unsigned short unResult;
    unsigned char ucID;         // f[^PoCg
    unsigned char sWrite[4];    // Mobt@
    unsigned char sRead[4];     // Mobt@
    DWORD dwWrite;              // MoCg
    DWORD dwRead;               // MoCg

    if (m_nId == nId && m_bOpen && cCh >= 1 && cCh <= 6)
        {
        ucID = (unsigned char)m_nId | 0x40;      // 1oCgڂ̃f[^
        switch (cCh)
            {
        case 1: stRelay.BIT.uRelay1 = cOnOff ? 1 : 0; break;
        case 2: stRelay.BIT.uRelay2 = cOnOff ? 1 : 0; break;
        case 3: stRelay.BIT.uRelay3 = cOnOff ? 1 : 0; break;
        case 4: stRelay.BIT.uRelay4 = cOnOff ? 1 : 0; break;
        case 5: stRelay.BIT.uRelay5 = cOnOff ? 1 : 0; break;
        case 6: stRelay.BIT.uRelay6 = cOnOff ? 1 : 0; break;
            }
        sprintf((char *)sWrite, "%c%c", ucID, stRelay.BYTE);
        WriteFile(m_hComm, (LPCVOID)sWrite, (DWORD)2, (LPDWORD)&dwWrite, NULL);

        if (nId != 0)
            {
            // uIDw肳Ă
            ReadFile(m_hComm, (LPVOID)sRead, (DWORD)2, (LPDWORD)&dwRead, NULL);
            if (dwRead == 2)
                {
                // ɃXe[^XMł
                unResult = sRead[0];
                unResult <<= 8;
                unResult |= sRead[1];
                }
            else
                unResult = 0xFFFF;
            }
        else
            unResult = 0;   // Suɑ΂ꍇ̓Xe[^X
        }
    else
        unResult = 0xFFFF;
    return unResult;
    }


SACOMSW_SS4248_API BOOL _stdcall SacomswSS4248_In(short nId, char cCh, char * pcOnOff)
    {
    BOOL bResult;

    if (m_nId == nId && m_bOpen && cCh >= 1 && cCh <= 6)
        {
        switch (cCh)
            {
        case 1:  *pcOnOff = stRelay.BIT.uRelay1 ? 1 : 0; break;
        case 2:  *pcOnOff = stRelay.BIT.uRelay2 ? 1 : 0; break;
        case 3:  *pcOnOff = stRelay.BIT.uRelay3 ? 1 : 0; break;
        case 4:  *pcOnOff = stRelay.BIT.uRelay4 ? 1 : 0; break;
        case 5:  *pcOnOff = stRelay.BIT.uRelay5 ? 1 : 0; break;
        case 6:  *pcOnOff = stRelay.BIT.uRelay6 ? 1 : 0; break;
            }
        bResult = TRUE;
        }
    else
        bResult = FALSE;
    return bResult;
    }

